<template>
    <div class="row">
        <div class="col-4 mt-auto">
            <BudgetCodeTypeSelector
                v-model:codeType="codeType"
                @change="updateAll"/>
        </div>
    </div>
    <div class="row mt-3">
        <div class="col-12">
            <BudgetAliasesTree
                :aliasesList="aliasesList"
                :codesList="codesList"
                :presentationId="presentationId"
                :codeType="codeType"
                :editMode="editMode"/>
        </div>
    </div>
</template>

<script>
    import BudgetEditModeSelector from '../BudgetEditModeSelector'
    import BudgetAliasesTree from '../Aliases/BudgetAliasesTree'
    import BudgetCodeTypeSelector from '../Codes/BudgetCodeTypeSelector'
    import { BudgetAliasesService } from '../../services/budgetAliasesService'
    import { BudgetCodesService } from '../../services/budgetCodesService'
    import { defaultHandleErrorFunction } from '@/services/http-common'
    import { codeTypes } from '@/services/values'
    export default {
        name: 'BudgetAliasesList',
        components: {
            BudgetEditModeSelector,
            BudgetAliasesTree,
            BudgetCodeTypeSelector
        },
        props: {
            municipalityId: Number,
            presentationId: Number,
            editMode: Boolean
        },
        data() {
            return {
                codeType: codeTypes.INCOME,
                aliasesList: [],
                codesList: [],
            }
        },
        methods: {
            updateAliasesList() {
                return budgetAliasesService
                    .get(this.presentationId, this.codeType)
                    .then(response => this.aliasesList = response
                        .data
                        .sort((a, b) => (a.codeNumber || 'z').replace(/\s/g, '').localeCompare((b.codeNumber || 'z').replace(/\s/g, ''))))
                    .catch(defaultHandleErrorFunction);
            },
            updateCodesList() {
                return budgetCodesService
                    .get(this.municipalityId, this.codeType, true)
                    .then(response => this.codesList = response
                        .data
                        .sort((a, b) => a.number.replace(/\s/g, '').localeCompare(b.number.replace(/\s/g, ''))))
                    .catch(defaultHandleErrorFunction);
            },
            updateAll() {
                this.updateCodesList();
                this.updateAliasesList();
            }
        },
        created() {
            this.updateAll();
        }
    };

    const budgetAliasesService = new BudgetAliasesService();
    const budgetCodesService = new BudgetCodesService();
</script>